NAME
revdep - checks for missing libraries of installed packages
SYNOPSIS
revdep [-h] [-v|-vv|-vvv|-vvvv] [package...]
DESCRIPTION
revdep checks for missing libraries of installed packages using elfutils'
libelf and the same algorithm that ld.so(8) uses.
OPTIONS
-h    The option -h displays help
-d    Specify an alternate location for the package database
-c    Specify an alternate location for ld.so.conf
-r    Specify an alternate directory for revdep package config
-i    Comma-separated list of ports to ignore
-v    Formatted listing
-vv   Include errorous files
-vvv  Include precise file errors
-vvvv Show debug/trace
EXAMPLE
Try this command to list broken packages:
 
$ revdep
 
Use this command to rebuild packages on your system:
 
# prt-get update -fr $(revdep)
ADDITIONAL LIBRARY DIRECTORIES
Upon startup, revdep searches the /etc/revdep.d directory for files named
after ports. If any are found, any directories (assumed to be absolute
pathes and delimited by newlines) within the file are added to a list of
port specific directories to search if a library dependency is not found
in one of the many standard locations (as specified by ld.so(8)).

If a port is discovered to have library dependencies that are in a
non-standard location, then a file, as specified above, should be created.

For example, if the port "firefox" has a "libxul.so" dependency in a
the non-standard directory "/usr/lib/firefox" then a file named "firefox"
should be created under "/etc/revdep.d" with a single line containing
"/usr/lib/firefox". This will tell revdep where to find firefox's "libxul.so"
when looking for its library dependencies, reducing one source of false
positives. Ideally, this file would be included with the port's own packaging
as well.
NOTES
C++ rewrite inspired by Johannes Winkelmann's <jw@tks6.net> shell revdep.
Contributed to design Danny Rawlins <contact@romster.me>.
SEE ALSO
ld.so(8), prt-get(8), pkginfo(1)
AUTHOR
James Buren, ryuo @ freenode 
